=== debian/changelog ===
ecflow (5.13.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 24 Jun 2024 10:56:34 +0100

ecflow (5.12.4-1) unstable; urgency=medium

  * New upstream release
  * Remove obsolete sleep_for.patch
  * Make Debian Science team the maintainer
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Apr 2024 08:19:47 +0100

ecflow (5.12.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 16 Mar 2024 10:03:06 +0000

ecflow (5.12.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Mar 2024 07:01:25 +0000

ecflow (5.12.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 08 Mar 2024 07:04:30 +0000
