=== debian/changelog ===
ecflow (5.13.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Jul 2024 08:50:06 +0100

ecflow (5.13.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Jul 2024 09:06:31 +0100
